;**************************************************
;    Cg[X{bg,"F1~j"              *
;**************************************************
;                                                 *
;    Filename:	    f1mini01.asm                  *
;    Date:          2003-02-14                    *
;    File Version:  1.02                          *
;                                                 *
;    Author:        KIKUCHI Yoshinori             *
;    Company:       Toyo-Linx Co.,Ltd.            *
;                                                 *
;                                                 *
;**************************************************
;                                                 *
;    Files required:                              *
;      p16f84a.inc                                *
;                                                 *
;                                                 *
;**************************************************
;                                                 *
;    Notes:                                       *
;                                                 *
;@@2002. 4. 2/x̐ݒl`ѕύX^Ζ  *
; 	@@@  CW3,CW4  V                     @*
;    2002. 4.26/B6061aɑΉ                      *
;    2002. 4.30/d݂LED_                   *
;    2002. 5. 6/hyper[hǉ                   *
;    2002. 5. 8/hyper[h폜                   *
;               ZbgAbv[hǉ            *
;    2002. 6. 6/ײڰݻŒ~ǉ       *
;    2003. 2.14/nɔ̃CɕύX            *
;                                                 *
;**************************************************


	list      p=16F84A		;
	#include <p16F84A.inc>		;

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC

; '__CONFIG' directive is used to embed configuration 
; data within .asm file.The lables following the directive
; are located in therespective .inc file.
; See respective data sheet for additional information on
; configuration word.


;**************************************************
;	ϐ̈̒`(ėp̧ڼ޽ / 0Ch-4Fh)
;**************************************************
	cblock	0x0C

w_temp		;Wڼ޽ꎞۊ
STATUS_temp	;STATUSڼ޽ꎞۊ

DataPORTA	;PORTA̒l
DataPORTB	;PORTB̒l

		;ėpٰ߶
LoopCountL	; 8bit
LoopCountH	; 8bit

		;ĳϗpٰ߶
LoopTimerL	; 8bit
LoopTimerH	; 8bit
LoopStack	; Ϻى

StandardCnt	;(-1/200us)
PWMCnt0		;PWMp(RA0)
PWMCnt1		;         (RA1)
PWMCnt2		;         (RA2)
PWMCnt3		;         (RA3)
SpeedLeft	;ԗւ̽߰
SpeedRight	;Eԗւ̽߰

LineData	;ײݏ
LineDataOld	;Oײݏ

cnt0		;for RS232C-Control
cnt1		;	V
sdata		;	V
rdata		;	V
scnt		;	V
delyh		;	V
delyl		;	V

		;'dtin'ٰ
LorR		; 'L'or'R' \
MsgNum		; үް
MsgIndex	; ү޲ޯ
StoreAddr	; ꂽް̽ıڽ

RcvBuf		;Mޯ̧
RcvBuf1		;
RcvBuf2		;

Index		;ðق̲ޯ
Index_temp	;
TableAddrL	;ðِ擪ڽ(8ޯ)
TableAddrH	;              (5ޯ)

HexData		;HEXް
bcd_data1	;BCD Data (1)
bcd_data10	;BCD Data (10)
bcd_data100	;BCD Data (100)
rpt_cnt		;Repeat Count(bcd2hexŎgp)

;--------------------------------------------------
;	EEPROMޯ߂
;--------------------------------------------------
ProgNo		;۸

T2l3l		; } EӰ
T2l3r		;          Ӱ
T2l2l		;       
T2l2r		;
T2l1l		;       
T2l1r		;

Cw4l		;i 4 Ӱ
Cw4r		;         EӰ

T2r1l		;E  Ӱ
T2r1r		;          EӰ
T2r2l		;       
T2r2r		;
T2r3l		;       }
T2r3r		;

	endc


;**************************************************
;	vO[h
;**************************************************
LINE	equ	0	;̐F
			; 0-nɔ
			; 1-nɍ


;**************************************************
;	萔̐ݒ
;**************************************************
baud	equ	d'34'*5	;XT=20MHz,9600baud

cr	equ	0x0d
bs	equ	0x08


;**************************************************
;	vOX^[g
;**************************************************
	ORG	0x000		;processor reset vector
	clrf	PCLATH		;߰ޑڼ޽ر
	btfss	PORTB,0		;SW3(RB0)_?
	goto	setup		;Setup Program
	goto	initial		;go to beginning of program


;**************************************************
;	荞ݕ
;**************************************************
	ORG	0x004		;interrupt vector location
int
	movwf	w_temp		;save off current W register contents
	movf	STATUS,w	;move STATUS register into W register
	movwf	STATUS_temp	;save off contents of STATUS register

	btfsc	INTCON,T0IF
	goto	intTMR0		;0

int_00				;ٰ݂
				; ߂
	movf	STATUS_temp,w	;retrieve copy of STATUS register
	movwf	STATUS		;restore pre-isr STATUS register contents
	swapf	w_temp,f
	swapf	w_temp,w	;restore pre-isr W register contents
	retfie			;return from interrupt


;**************************************************
;	CjVCY
;**************************************************
initial
	call	illumination	;LED_

	call	reg_clr		;̧ڼ޽ر

	movlw	1		;
	movwf	StandardCnt

	call	load		;EEPROM->̧ڼ޽

	bsf	STATUS,RP0	;ݸ=1
	movlw	B'10000'	;PORTA o
	movwf	TRISA
	movlw	B'11111111'	;PORTB 
	movwf	TRISB
	movlw	B'00000001'	;OPTIONڼ޽
	movwf	OPTION_REG
	bcf	STATUS,RP0	;ݸ=0

	movlw	B'00000'	;PORTA Ƽٱ
	movwf	PORTA

	movlw	6		;϶(200us)
	movwf	TMR0
	movlw	B'10100000'	;ϊݲȰ
	movwf	INTCON

	movlw	H'01'
	subwf	ProgNo,w
	btfsc	STATUS,Z
	goto	straight
	goto	trace


;**************************************************
;	isCvO
;**************************************************
straight
	btfsc	PORTA,4		;StartSW ݑ҂
	goto	straight
	call	timer10
	btfsc	PORTA,4
	goto	straight
;--------------------------------------------------
	call	motor_st	;ӰN
	call	cw4		;sJn
;--------------------------------------------------
straight_10
	call	touch		;ݻ  ҂
	btfss	STATUS,C
	goto	straight_10
;--------------------------------------------------
	call	stop		;~
	goto	straight


;**************************************************
;	Cg[XCvO
;**************************************************
trace
	btfsc	PORTA,4		;StartSW ݑ҂
	goto	trace
	call	timer10
	btfsc	PORTA,4
	goto	trace
;--------------------------------------------------
	call	motor_st	;ӰN
;--------------------------------------------------
trace_00
if LINE==0
	comf	PORTB,w		;ײݏ()
else
	movf	PORTB,w		;ײݏ()
endif
	andlw	B'11110000'
	movwf	LineData
	subwf	LineDataOld,w	;OײݏƔr
	btfsc	STATUS,Z
	goto	trace_19	;-~ȊO
				;      ύXȂ
	movf	LineData,w	;Ⴄ-XV
	movwf	LineDataOld
;--------------------------------------------------
trace_10
	movlw	B'10000000'	;ij
	subwf	LineData,w
	btfsc	STATUS,Z
	goto	trace_11
	movlw	B'11000000'	;ij
	subwf	LineData,w
	btfsc	STATUS,Z
	goto	trace_12
	movlw	B'01000000'	;ij
	subwf	LineData,w
	btfsc	STATUS,Z
	goto	trace_13
	movlw	B'01100000'	;
	subwf	LineData,w
	btfsc	STATUS,Z
	goto	trace_14
	movlw	B'00100000'	;Eij
	subwf	LineData,w
	btfsc	STATUS,Z
	goto	trace_15
	movlw	B'00110000'	;Eij
	subwf	LineData,w
	btfsc	STATUS,Z
	goto	trace_16
	movlw	B'00010000'	;Eij
	subwf	LineData,w
	btfsc	STATUS,Z
	goto	trace_17
trace_19
	movlw	B'11110000'	;Oꂽ
	subwf	LineData,w	;ih~j
	btfss	STATUS,Z
	goto	trace_20
	call	timer10
if LINE==0
	comf	PORTB,w		;ײݏ()
else
	movf	PORTB,w		;ײݏ()
endif
	andlw	B'11110000'
	sublw	B'11110000'
	btfss	STATUS,Z
	goto	trace_20
	goto	trace_18
trace_11
	call	t2r3		;Eij
	goto	trace_20
trace_12
	call	t2r2		;Eij
	goto	trace_20
trace_13
	call	t2r1		;Eij
	goto	trace_20
trace_14
	call	cw4		;i
	goto	trace_20
trace_15
	call	t2l1		;ij
	goto	trace_20
trace_16
	call	t2l2		;ij
	goto	trace_20
trace_17
	call	t2l3		;ij
	goto	trace_20
trace_18
	call	stop		;~
	goto	trace		; StartSw ݑ҂
;--------------------------------------------------
trace_20
	call	touch		;ݻ
	btfss	STATUS,C
	goto	trace_00	;
	goto	trace_18	;݁~


;**************************************************
;	[^Xs[hZbg
;**************************************************
cw1				;](۰)
;	bcf	INTCON,T0IE
;	movf	Cw1l,w
;	movwf	SpeedLeft
;	movf	Cw1r,w
;	movwf	SpeedRight
;	bsf	INTCON,T0IE
;	return
cw2				;]()
;	bcf	INTCON,T0IE
;	movf	Cw2l,w
;	movwf	SpeedLeft
;	movf	Cw2r,w
;	movwf	SpeedRight
;	bsf	INTCON,T0IE
;	return
cw3				;]()
;	bcf	INTCON,T0IE
;	movf	Cw3l,w
;	movwf	SpeedLeft
;	movf	Cw3r,w
;	movwf	SpeedRight
;	bsf	INTCON,T0IE
;	return
cw4				;](į)
	bcf	INTCON,T0IE
	movf	Cw4l,w
	movwf	SpeedLeft
	movf	Cw4r,w
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
;--------------------------------------------------
ccw1				;t](۰)
;	bcf	INTCON,T0IE
;	movf	Cw1l,w
;	sublw	0
;	movwf	SpeedLeft
;	movf	Cw1r,w
;	sublw	0
;	movwf	SpeedRight
;	bsf	INTCON,T0IE
;	return
ccw2				;t]()
;	bcf	INTCON,T0IE
;	movf	Cw2l,w
;	sublw	0
;	movwf	SpeedLeft
;	movf	Cw2r,w
;	sublw	0
;	movwf	SpeedRight
;	bsf	INTCON,T0IE
;	return
ccw3				;t]()
;	bcf	INTCON,T0IE
;	movf	Cw3l,w
;	sublw	0
;	movwf	SpeedLeft
;	movf	Cw3r,w
;	sublw	0
;	movwf	SpeedRight
;	bsf	INTCON,T0IE
;	return
ccw4				;t](į)
	bcf	INTCON,T0IE
	movf	Cw4l,w
	sublw	0
	movwf	SpeedLeft
	movf	Cw4r,w
	sublw	0
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
;--------------------------------------------------
t2r1				;E()
	bcf	INTCON,T0IE
	movf	T2r1l,w
	movwf	SpeedLeft
	movf	T2r1r,w
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
t2r2				;E()
	bcf	INTCON,T0IE
	movf	T2r2l,w
	movwf	SpeedLeft
	movf	T2r2r,w
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
t2r3				;E()
	bcf	INTCON,T0IE
	movf	T2r3l,w
	movwf	SpeedLeft
	movf	T2r3r,w
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
;--------------------------------------------------
t2l1				;()
	bcf	INTCON,T0IE
	movf	T2l1l,w
	movwf	SpeedLeft
	movf	T2l1r,w
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
t2l2				;()
	bcf	INTCON,T0IE
	movf	T2l2l,w
	movwf	SpeedLeft
	movf	T2l2r,w
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
t2l3				;()
	bcf	INTCON,T0IE
	movf	T2l3l,w
	movwf	SpeedLeft
	movf	T2l3r,w
	movwf	SpeedRight
	bsf	INTCON,T0IE
	return
;--------------------------------------------------
stop				;~
	bcf	INTCON,T0IE
	clrf	SpeedLeft
	clrf	SpeedRight
	bsf	INTCON,T0IE
	return
;--------------------------------------------------
motor_st			;ӰN
	bcf	INTCON,T0IE
	movlw	B'01111'	;ڰ
	movwf	PORTA
	call	timer100
	movlw	B'00101'
	movwf	PORTA
	call	timer100
	bsf	INTCON,T0IE
	return


;**************************************************
;	^b`ZT
;**************************************************
touch
	btfsc	PORTB,2		;ݻ  ҂
	goto	touch_01
	call	timer10
	btfsc	PORTB,2
	goto	touch_01
	goto	touch_03
touch_01
	btfsc	PORTB,3		;ݻ  ҂
	goto	touch_02
	call	timer10
	btfsc	PORTB,3
	goto	touch_02
touch_03
	bsf	STATUS,C	;ݻ 
	return
touch_02
	bcf	STATUS,C	;ݻ 
	return


;**************************************************
;	\tg^C}(PEFCg)
;**************************************************
timer100			;100ms
	movlw	H'8E'
	movwf	LoopTimerL
	movlw	H'0B1'
	movwf	LoopTimerH
timer100_01
	movf	LoopTimerL,w
	iorwf	LoopTimerH,w
	btfsc	STATUS,Z
	return
	movlw	1
	subwf	LoopTimerL,f
	btfsc	STATUS,C
	goto	timer100_01
	decf	LoopTimerH,f
	goto	timer100_01
;--------------------------------------------------
timer10				;10ms
	movlw	H'0C1'
	movwf	LoopTimerL
	movlw	H'11'
	movwf	LoopTimerH
	goto	timer100_01
;--------------------------------------------------
timer1000			;1000ms=1s
	movlw	D'10'
	movwf	LoopStack
timer1000_01
	call	timer100
	decfsz	LoopStack,f
	goto	timer1000_01
	return


;**************************************************
;	^C}(TMR0) / PWM
;**************************************************
intTMR0
	bcf	INTCON,T0IF	;荞׸޸ر
	movlw	6		;ύĽ
	movwf	TMR0

	decfsz	StandardCnt,f
	goto	intTMR0_20
;--------------------------------------------------
intTMR0_10
	movlw	D'100'		;
	movwf	(StandardCnt)

	btfsc	SpeedLeft,7
	goto	intTMR0_11
	movf	SpeedLeft,w	;ԗ,]
	movwf	PWMCnt0
	clrf	PWMCnt1
	goto	intTMR0_12
intTMR0_11
	movf	SpeedLeft,w	;ԗ,t]
	sublw	0
	movwf	PWMCnt1
	clrf	PWMCnt0
intTMR0_12

	btfsc	SpeedRight,7
	goto	intTMR0_13
	movf	SpeedRight,w	;Eԗ,]
	movwf	PWMCnt2
	clrf	PWMCnt3
	goto	intTMR0_14
intTMR0_13
	movf	SpeedRight,w	;Eԗ,t]
	sublw	0
	movwf	PWMCnt3
	clrf	PWMCnt2
intTMR0_14

	goto	intTMR0_30
;--------------------------------------------------
intTMR0_20
	movf	PWMCnt0,w	;0ȊÔƂ
	btfss	STATUS,Z	; -1
	decf	PWMCnt0,f
	movf	PWMCnt1,w
	btfss	STATUS,Z
	decf	PWMCnt1,f
	movf	PWMCnt2,w
	btfss	STATUS,Z
	decf	PWMCnt2,f
	movf	PWMCnt3,w
	btfss	STATUS,Z
	decf	PWMCnt3,f
;--------------------------------------------------
intTMR0_30
	movf	PORTA,w		;Ēl<>0̂Ƃ
	andlw	H'0F0'		; PORTHigho
	movwf	DataPORTA
	movf	PWMCnt0,w
	btfss	STATUS,Z
	bsf	DataPORTA,0
	movf	PWMCnt1,w
	btfss	STATUS,Z
	bsf	DataPORTA,1
	movf	PWMCnt2,w
	btfss	STATUS,Z
	bsf	DataPORTA,2
	movf	PWMCnt3,w
	btfss	STATUS,Z
	bsf	DataPORTA,3
	movf	DataPORTA,w
	movwf	PORTA
;--------------------------------------------------
intTMR0_40
	goto	int_00


;**************************************************
;	C~l[V
;**************************************************
illumination
	bsf	STATUS,RP0	;ݸ=1
	movlw	B'00000000'	;PORTB o
	movwf	TRISB
	bcf	STATUS,RP0	;ݸ=0

	movlw	B'11111110'	;PORTB Ƽٱ
	movwf	PORTB

illumi_10
	movlw	D'24'
	movwf	LoopStack
illumi_11
	call	timer100
	bsf	STATUS,C
	rlf	PORTB,f
	btfss	STATUS,C
	bcf	PORTB,0
	decfsz	LoopStack,f
	goto	illumi_11
	return


;**************************************************
;	ZbgAbv[h
;**************************************************
setup
	call	reg_clr		;̧ڼ޽ر

	movlw	B'00000000'	;݋֎~
	movwf	INTCON

	bsf	STATUS,RP0	;ݸ=1
	movlw	B'10000'	;PORTA o
	movwf	TRISA
	movlw	B'11111101'	;PORTB o
	movwf	TRISB
	movlw	B'00000001'	;OPTIONڼ޽
	movwf	OPTION_REG
	bcf	STATUS,RP0	;ݸ=0

	movlw	B'00000'	;PORTA Ƽٱ
	movwf	PORTA
	movlw	B'00000010'	;PORTB Ƽٱ
	movwf	PORTB

	call	copyright

setup_01
	btfss	PORTB,0		;SW3  ҂
	goto	setup_01


;**************************************************
;	vȎI
;**************************************************
menu
	call	load		;EEPROM->̧ڼ޽

	clrf	Index		;\
	movlw	low menu_msg
	movwf	TableAddrL
	movlw	high menu_msg
	movwf	TableAddrH
	movlw	menu_msge-menu_msg+1
	movwf	LoopCountL
	call	txout

menu_02
	call	rxone		;1M

	movlw	'1'		;͒l̊mF
	subwf	rdata,w
	btfsc	STATUS,Z
	goto	menu_03
	movlw	'2'
	subwf	rdata,w
	btfsc	STATUS,Z
	goto	menu_04
	goto	menu_02		;͈͊O
menu_03
	movlw	'1'
	call	send
	movlw	H'01'		;ProgNo̾
	movwf	ProgNo
	goto	set_straight	;is
menu_04
	movlw	'2'
	call	send
	movlw	H'02'		;ProgNo̾
	movwf	ProgNo
	goto	set_trace	;ײڰ

;///// ү /////
menu_msg
	dt	cr
	dt	"*** MENU ***",cr
	dt	"[1]Straight [2]Trace >"
menu_msge	equ	$-1


;**************************************************
;	is̐ݒ
;**************************************************
set_straight
	clrf	Index
	movlw	low st_msg0
	movwf	TableAddrL
	movlw	high st_msg0
	movwf	TableAddrH
	movlw	st_msg0e-st_msg0+1
	movwf	LoopCountL
	call	txout

	movlw	Cw4l
	movwf	FSR
	call	lrbcd_txout

	movlw	st_msg2e-st_msg2+1
	movwf	LoopCountL
	call	txout

;----- Cw4l ---------------------------------------
	clrf	MsgNum
	movlw	Cw4l
	movwf	StoreAddr
	call	ldtin

;----- Cw4r ---------------------------------------
	incf	StoreAddr,f
	call	rdtin

	call	do_you_save
	goto	menu

;///// ү /////
st_msg0
	dt	cr,cr
	dt	"- Straight -",cr
st_msg0e	equ	$-1

st_msg2
	dt	" (0-100)",cr
st_msg2e	equ	$-1


;**************************************************
;	Cg[X̐ݒ
;**************************************************
set_trace
	clrf	Index
	movlw	low tr_msg0
	movwf	TableAddrL
	movlw	high tr_msg0
	movwf	TableAddrH
	movlw	tr_msg0e-tr_msg0+1
	movwf	LoopCountL
	call	txout

	movlw	T2l3l
	movwf	FSR

	movlw	tr_msg1e-tr_msg1+1
	movwf	LoopCountL
	call	txout

	call	lrbcd_txout
	call	send_cr

	movlw	tr_msg2e-tr_msg2+1
	movwf	LoopCountL
	call	txout

	call	lrbcd_txout
	call	send_cr

	movlw	tr_msg3e-tr_msg3+1
	movwf	LoopCountL
	call	txout

	call	lrbcd_txout
	call	send_cr

	movlw	tr_msg4e-tr_msg4+1
	movwf	LoopCountL
	call	txout

	call	lrbcd_txout
	call	send_cr

	movlw	tr_msg5e-tr_msg5+1
	movwf	LoopCountL
	call	txout

	call	lrbcd_txout
	call	send_cr

	movlw	tr_msg6e-tr_msg6+1
	movwf	LoopCountL
	call	txout

	call	lrbcd_txout
	call	send_cr

	movlw	tr_msg7e-tr_msg7+1
	movwf	LoopCountL
	call	txout

	call	lrbcd_txout

	movlw	tr_msg8e-tr_msg8+1
	movwf	LoopCountL
	call	txout

;----- T2l3l --------------------------------------
	movlw	tr_msg1e-tr_msg1+1
	movwf	MsgNum
	movlw	tr_msg1-tr_msg0
	movwf	MsgIndex
	movwf	Index
	movlw	T2l3l
	movwf	StoreAddr
	call	ldtin

;----- T2l3r --------------------------------------
	movf	MsgIndex,w
	movwf	Index
	incf	StoreAddr,f
	call	rdtin

;----- T2l2l --------------------------------------
	movlw	tr_msg2-tr_msg0
	movwf	MsgIndex
	incf	StoreAddr,f
	call	ldtin

;----- T2l2r --------------------------------------
	movf	MsgIndex,w
	movwf	Index
	incf	StoreAddr,f
	call	rdtin

;----- T2l1l --------------------------------------
	movlw	tr_msg3-tr_msg0
	movwf	MsgIndex
	incf	StoreAddr,f
	call	ldtin

;----- T2l1r --------------------------------------
	movf	MsgIndex,w
	movwf	Index
	incf	StoreAddr,f
	call	rdtin

;----- Cw4l ---------------------------------------
	movlw	tr_msg4-tr_msg0
	movwf	MsgIndex
	incf	StoreAddr,f
	call	ldtin

;----- Cw4r ---------------------------------------
	movf	MsgIndex,w
	movwf	Index
	incf	StoreAddr,f
	call	rdtin

;----- T2r1l --------------------------------------
	movlw	tr_msg5-tr_msg0
	movwf	MsgIndex
	incf	StoreAddr,f
	call	ldtin

;----- T2r1r --------------------------------------
	movf	MsgIndex,w
	movwf	Index
	incf	StoreAddr,f
	call	rdtin

;----- T2r2l --------------------------------------
	movlw	tr_msg6-tr_msg0
	movwf	MsgIndex
	incf	StoreAddr,f
	call	ldtin

;----- T2r2r --------------------------------------
	movf	MsgIndex,w
	movwf	Index
	incf	StoreAddr,f
	call	rdtin

;----- T2r3l --------------------------------------
	movlw	tr_msg7-tr_msg0
	movwf	MsgIndex
	incf	StoreAddr,f
	call	ldtin

;----- T2r3r --------------------------------------
	movf	MsgIndex,w
	movwf	Index
	incf	StoreAddr,f
	call	rdtin

	call	do_you_save
	goto	menu

;///// ү /////
if LINE==0 ;nɔ ----------------------------

tr_msg0
	dt	cr,cr
	dt	"- Trace -",cr
tr_msg0e	equ	$-1

tr_msg1
	dt	"oxxx "
tr_msg1e	equ	$-1

tr_msg2
	dt	"ooxx "
tr_msg2e	equ	$-1

tr_msg3
	dt	"xoxx "
tr_msg3e	equ	$-1

tr_msg4
	dt	"xoox "
tr_msg4e	equ	$-1

tr_msg5
	dt	"xxox "
tr_msg5e	equ	$-1

tr_msg6
	dt	"xxoo "
tr_msg6e	equ	$-1

tr_msg7
	dt	"xxxo "
tr_msg7e	equ	$-1

tr_msg8
	dt	" (0-100)",cr,cr
tr_msg8e	equ	$-1

else ;nɍ ----------------------------------

tr_msg0
	dt	cr,cr
	dt	"- Trace -",cr
tr_msg0e	equ	$-1

tr_msg1
	dt	"xooo "
tr_msg1e	equ	$-1

tr_msg2
	dt	"xxoo "
tr_msg2e	equ	$-1

tr_msg3
	dt	"oxoo "
tr_msg3e	equ	$-1

tr_msg4
	dt	"oxxo "
tr_msg4e	equ	$-1

tr_msg5
	dt	"ooxo "
tr_msg5e	equ	$-1

tr_msg6
	dt	"ooxx "
tr_msg6e	equ	$-1

tr_msg7
	dt	"ooox "
tr_msg7e	equ	$-1

tr_msg8
	dt	" (0-100)",cr,cr
tr_msg8e	equ	$-1

endif ;--------------------------------------------


;**************************************************
;	eLXgM
;**************************************************
txout
	call	get_table
	call	send
	incf	Index,f
	decfsz	LoopCountL,f
	goto	txout
	return


;**************************************************
;	BCDM
;**************************************************
lbcd_txout
	movwf	HexData
	movlw	'L'
	goto	bcd_txout_01
rbcd_txout
	movwf	HexData
	movlw	'R'
bcd_txout_01
	call	send
	movlw	'['
	call	send
	call	hex2bcd
	movlw	H'30'
	iorwf	bcd_data100,w
	call	send
	movlw	H'30'
	iorwf	bcd_data10,w
	call	send
	movlw	H'30'
	iorwf	bcd_data1,w
	call	send
	movlw	']'
	call	send
	return

lrbcd_txout
	movf	INDF,w		;FSR:Ḻڽ
	call	lbcd_txout
	incf	FSR,f
	movlw	' '
	call	send
	movf	INDF,w
	call	rbcd_txout
	incf	FSR,f
	return


;**************************************************
;	Rs[CgM
;**************************************************
copyright
	movlw	copyrightTable-0x2100
	movwf	EEADR
	movlw	copyrightTablee-copyrightTable+1
	movwf	LoopCountL
copyright_01
	call	rd_eeprom
	call	send
	incf	EEADR,f
	decfsz	LoopCountL,f
	goto	copyright_01
	return


;**************************************************
;	f[^G[̃eLXg
;**************************************************
send_NG
	movlw	' '
	call	send
	movlw	'N'
	call	send
	movlw	'G'
	call	send
	movlw	cr
	call	send
	return


;**************************************************
;	CR M
;**************************************************
send_cr
	movlw	cr
	call	send
	return


;**************************************************
;	EEPROMɃZ[u邩q˂
;**************************************************
do_you_save
	clrf	Index
	movlw	low save_msg0
	movwf	TableAddrL
	movlw	high save_msg0
	movwf	TableAddrH
	movlw	save_msg0e-save_msg0+1
	movwf	LoopCountL
	call	txout

do_you_save_01
	call	rxone		;1M

	bcf	rdata,5		;啶
	movlw	'Y'		;'Y'or'y' -> 
	subwf	rdata,w
	btfsc	STATUS,Z
	goto	do_you_save_20

do_you_save_10			;ނȂ
	clrf	Index
	movlw	low save_msg3
	movwf	TableAddrL
	movlw	high save_msg3
	movwf	TableAddrH
	movlw	save_msg3e-save_msg3+1
	movwf	LoopCountL
	call	txout
	retlw	H'01'

do_you_save_20			;
	call	save
	iorlw	H'00'
	btfss	STATUS,Z
	goto	do_you_save_21
	clrf	Index		;OK
	movlw	low save_msg1
	movwf	TableAddrL
	movlw	high save_msg1
	movwf	TableAddrH
	movlw	save_msg1e-save_msg1+1
	movwf	LoopCountL
	call	txout
	retlw	H'00'
do_you_save_21
	clrf	Index		;޴װ
	movlw	low save_msg2
	movwf	TableAddrL
	movlw	high save_msg2
	movwf	TableAddrH
	movlw	save_msg2e-save_msg2+1
	movwf	LoopCountL
	call	txout
	retlw	H'81'

;///// ү /////
save_msg0
	dt	"Save?(y/n) >"
save_msg0e	equ	$-1

save_msg1
	dt	"Success!",cr
save_msg1e	equ	$-1

save_msg2
	dt	"Error!",cr
save_msg2e	equ	$-1

save_msg3
	dt	"Cancel",cr
save_msg3e	equ	$-1


;**************************************************
;	bZ[W BCD 3 
;**************************************************
ldtin
	movlw	'L'
	goto	dtin_00
rdtin
	movlw	'R'
dtin_00
	movwf	LorR
dtin
	movf	MsgNum,w
	btfsc	STATUS,Z
	goto	dtin_02
	movwf	LoopCountL
	call	txout
dtin_02
	movf	LorR,w
	call	send
	movlw	'?'
	call	send
	movlw	' '
	call	send
	call	input_bcd
	btfsc	STATUS,C
	goto	dtin_01
	btfsc	STATUS,Z
	return
	movf	StoreAddr,w
	movwf	FSR
	movf	HexData,w
	movwf	INDF
	return
dtin_01
	call	send_NG
	movf	MsgIndex,w
	movwf	Index
	goto	dtin


;**************************************************
;	BCD 3 
;**************************************************
input_bcd
	clrf	RcvBuf
	clrf	RcvBuf+1
	clrf	RcvBuf+2
	movlw	RcvBuf
	movwf	FSR
	movlw	D'3'
	movwf	LoopCountL

input_bcd_loop	;<---------------------------------

input_bcd_01
	call	rxone		;1M

	movlw	cr
	subwf	rdata,w
	btfsc	STATUS,Z
	goto	input_bcd_30	;Enter
	movlw	bs
	subwf	rdata,w
	btfsc	STATUS,Z
	goto	input_bcd_20	;BackSpace
	movlw	'0'
	subwf	rdata,w
	btfss	STATUS,C
	goto	input_bcd_loop
	movlw	'9'+1
	subwf	rdata,w
	btfsc	STATUS,C
	goto	input_bcd_loop

;----- '0'-'9' ------------------------------------
input_bcd_10
	movf	LoopCountL,f
	btfsc	STATUS,Z
	goto	input_bcd_loop	;3͍ς
	movf	rdata,w
	movwf	INDF
	incf	FSR,f
	decf	LoopCountL,f
	movf	rdata,w
	call	send
	goto	input_bcd_loop

;----- BackSpace ----------------------------------
input_bcd_20
	movlw	D'3'
	subwf	LoopCountL,w
	btfsc	STATUS,Z
	goto	input_bcd_loop	;
	decf	FSR,f
	clrf	INDF
	incf	LoopCountL,f
	movlw	bs
	call	send
	movlw	' '
	call	send
	movlw	bs
	call	send
	goto	input_bcd_loop

;----- Enter --------------------------------------
input_bcd_30
	movf	rdata,w
	call	send

	clrf	bcd_data1
	clrf	bcd_data10
	clrf	bcd_data100
	movlw	RcvBuf
	movwf	FSR
	movf	RcvBuf,f
	btfsc	STATUS,Z
	goto	input_bcd_37	;
	movf	RcvBuf+1,f
	btfsc	STATUS,Z
	goto	input_bcd_33
	movf	RcvBuf+2
	btfsc	STATUS,Z
	goto	input_bcd_32
input_bcd_31
	movf	INDF,w		;3
	andlw	H'0F'
	movwf	bcd_data100
	incf	FSR,f
input_bcd_32
	movf	INDF,w		;2̂ݓ
	andlw	H'0F'
	movwf	bcd_data10
	incf	FSR,f
input_bcd_33
	movf	INDF,w		;1̂ݓ
	andlw	H'0F'
	movwf	bcd_data1

	movf	bcd_data100,f	;͈(0-100)
	btfsc	STATUS,Z
	goto	input_bcd_36
	movlw	H'01'
	subwf	bcd_data100,w
	btfss	STATUS,Z
	goto	input_bcd_35
	movf	bcd_data10,w
	iorwf	bcd_data1,w
	btfsc	STATUS,Z
	goto	input_bcd_36

input_bcd_35			;͈͊O
	bsf	STATUS,C
	return
input_bcd_36			;OK
	call	bcd2hex
	bcf	STATUS,C
	bcf	STATUS,Z
	return
input_bcd_37			;
	bcf	STATUS,C
	bsf	STATUS,Z
	return


;**************************************************
;	1M
;**************************************************
rxone
	btfsc	PORTB,0
	goto	rxone
	call	recv
	return


;**************************************************
;	RS232C-Control
;	 RB0 :Receive-port
;	 RB1 :transmit-port
;	 mode:9600,8bit,non-parity,2stop,no-control
;**************************************************

recv	call	dlybith		;dlybit-half
	movlw	8
	movwf	scnt	
recv_1	call	dlybit
	bcf	STATUS,0	;CY=0
	btfsc	PORTB,0
	bsf	STATUS,0	;CY=1
	rrf	rdata
	decfsz	scnt,F
	goto	recv_1
	call	dlybit		;wait stop-bit
	call	dlybit
	movf	rdata,W		;rdata to w
	;movwf	PORTB		;w > PORTB
	return
;--------------------------------------------------
send	;movwf	PORTB		;out w to PORTB
	movwf	sdata		;store data
	movlw	8		;store bit-cnt
	movwf	scnt
	bcf	PORTB,1		;start-bit
	call	dlybit
send_2	rrf	sdata,F		;bit detect
	btfsc	STATUS,0	;cy?
	goto	send_3
	bcf	PORTB,1		;RB1=0
	goto	send_4
send_3	bsf	PORTB,1		;RB1=1
	nop			;timing-adjust
send_4	call	dlybit
	decfsz	scnt,F
	goto	send_2
	bsf	PORTB,1		;stop-bit
	call	dlybit		;wait stop-bit
	call	dlybit
	return
;--------------------------------------------------
dlybit	movlw	baud
dlyb_0	movwf	cnt0
dlyb_1	decfsz	cnt0,1
	goto	dlyb_1
	return
;--------------------------------------------------
dlybith	movlw	baud/2		;delay-bit-half
	goto dlyb_0

;**************************************************
;	EEPROM ubN[h
;**************************************************
load
	movlw	ProgNo
	movwf	FSR
	movlw	H'00'
	movwf	EEADR
	movlw	EEPEnd-EEPStart+1
	movwf	LoopCountL
load_01
	call	rd_eeprom
	movwf	INDF
	incf	FSR,f
	incf	EEADR,f
	decfsz	LoopCountL,f
	goto	load_01
	return


;**************************************************
;	EEPROM ubNZ[u
;**************************************************
save
	movlw	ProgNo
	movwf	FSR
	movlw	H'00'
	movwf	EEADR
	movlw	EEPEnd-EEPStart+1
	movwf	LoopCountL
save_01
	movf	INDF,w
	movwf	EEDATA
	call	wr_eeprom
	iorlw	H'00'
	btfss	STATUS,Z
	return			;Error
	incf	FSR,f
	incf	EEADR,f
	decfsz	LoopCountL,f
	goto	save_01
	retlw	H'00'		;OK


;**************************************************
;	EEPROM 1oCg[h
;**************************************************
rd_eeprom
	bsf	STATUS,RP0
	bsf	EECON1,RD
	bcf	STATUS,RP0
	movf	EEDATA,w
	return


;**************************************************
;	EEPROM 1oCgCg
;**************************************************
wr_eeprom
	bsf	STATUS,RP0
;	bcf	INTCON,GIE
	bsf	EECON1,WREN
	movlw	H'55'
	movwf	EECON2
	movlw	H'AA'
	movwf	EECON2
	bsf	EECON1,WR
;	bsf	INTCON,GIE
	bcf	EECON1,WREN
wr_eeprom_01
	btfsc	EECON1,WR
	goto	wr_eeprom_01
	bcf	EECON1,EEIF

	bcf	STATUS,RP0	;̧
	movf	EEDATA,w
	bsf	STATUS,RP0
	bsf	EECON1,RD
	bcf	STATUS,RP0
	subwf	EEDATA,w
	btfss	STATUS,Z
	retlw	H'81'		;̧װ
	retlw	H'00'		;OK


;**************************************************
;	e[ubNAbv
;**************************************************
get_table
	movf	Index,w
	movwf	Index_temp
	movf	TableAddrL,w
	addwf	Index_temp,f
	movf	TableAddrH,w
	movwf	PCLATH
	btfsc	STATUS,C
	incf	PCLATH,f
	movf	Index_temp,w
	movwf	PCL


;**************************************************
;	abc(unpack)gdwϊ
;**************************************************
bcd2hex
bcd2hex_1
	movf	bcd_data1,W
;	andlw	0x0F
	movwf	HexData

bcd2hex_10
	movf	bcd_data10,W
;	andlw	0x0F
	btfsc	STATUS,Z
	goto	bcd2hex_100
	movwf	rpt_cnt
	movlw	D'10'
bcd2hex_10_0
	addwf	HexData,F
	decfsz	rpt_cnt,F
	goto	bcd2hex_10_0

bcd2hex_100
	movf	bcd_data100,W
;	andlw	0x0F
	btfsc	STATUS,Z
	goto	bcd2hex_end
	movwf	rpt_cnt
	movlw	D'100'
bcd2hex_100_0
	addwf	HexData,F
	decfsz	rpt_cnt,F
	goto	bcd2hex_100_0

bcd2hex_end
	movf	HexData,W

	return


;**************************************************
;	gdwabc(unpack)ϊ
;**************************************************
hex2bcd
	clrf	bcd_data100
	clrf	bcd_data10
	clrf	bcd_data1
	movlw	0x64
hex2bcd_01
	subwf	HexData,f
	btfss	STATUS,C
	goto	hex2bcd_02
	incf	bcd_data100,f
	goto	hex2bcd_01
hex2bcd_02
	addwf	HexData,f
	movlw	0x0a
hex2bcd_03
	subwf	HexData,f
	btfss	STATUS,C
	goto	hex2bcd_04
	incf	bcd_data10,f
	goto	hex2bcd_03
hex2bcd_04
	addwf	HexData,w
	movwf	bcd_data1
	return


;**************************************************
;	t@CWX^NA
;**************************************************
reg_clr
	movlw	H'0C'		;̧ڼ޽ر
	movwf	FSR
reg_clr_00
	clrf	INDF
	incf	FSR,f
	movf	FSR,w
	sublw	H'50'
	btfss	STATUS,Z
	goto	reg_clr_00
	return


;**************************************************
;	EEPROM Data (2100h-213Fh)
;**************************************************
	org	0x2100

EEPStart	equ	$

eeProgNo	de	2	;۸

eeT2l3l		de	d'20'	; } Ӱ
eeT2l3r		de	d'50'	;          EӰ
eeT2l2l		de	d'30'	;       
eeT2l2r		de	d'50'	;
eeT2l1l		de	d'40'	;       
eeT2l1r		de	d'50'	;

eeCw4l		de	d'50'	;     4
eeCw4r		de	d'50'	;

eeT2r1l		de	d'50'	;E  Ӱ
eeT2r1r		de	d'40'	;          EӰ
eeT2r2l		de	d'50'	;       
eeT2r2r		de	d'30'	;
eeT2r3l		de	d'50'	;       }
eeT2r3r		de	d'20'	;

EEPEnd		equ	$-1


	org	0x2120
copyrightTable	de	0x0c
		de	"F1-mini Setup (c)2003 ToyoLinx",cr
copyrightTablee	equ	$-1


;**************************************************
	END		;directive 'end of program'
